#
# Black and White Encypted Shader decrypter
#
# V1.0
#
# The encryption is just a simple addition (ceaser-style) shift. It is just byte + 3.
# To decrypt, simply read each byte and subtract 3 from it's integer value.
#
# For instance [ 00010100 ] decrypted would be [ 00010001 ].
#
# Pass as an argument one of the .ceaser3 shader files. For example:
# "DecryptShader.py RoadCobbles.psh.caesar3"
#
# 

import struct
import sys
import os

######## Arguments #######################
if len(sys.argv) < 1:
	print "Missing Argument:  Must specify encrypted file"
	print
	raise SystemExit

filename = os.path.basename(sys.argv[1])
filedir = os.path.dirname(sys.argv[1])
if filedir != "":
	filedir += "/"
filenamenoext, filenameext = os.path.splitext(filename)
pathtoshadernoext = filedir+filenamenoext
pathtoshader = filedir+filenamenoext+filenameext
if not os.path.isfile(filedir+filenamenoext+filenameext):
	print
	print "ERROR:File in argument does not exist"
	print
	raise SystemExit


try:
	orfile = open(pathtoshader, 'rb')
except:
	print
	print "ERROR:Cannot open encypted shader file for reading"
	print "Why? File seems to exist. Persmission problems?"
	print
	raise SystemExit


try:
	owfile = open(pathtoshadernoext+".decrypt", 'wb')
except:
	print
	print "ERROR:Cannot open file for writing."
	print "Disk Full? Directory read-only?"
	print
	raise SystemExit
##########################################

readBuffer = ''
writeBuffer = ''

orfile.seek(0)
readBuffer = orfile.read()

byteNum = 0
maxNum = len(readBuffer)


while byteNum < maxNum:
	x = struct.unpack('<B', readBuffer[byteNum])[0]
	x = x - 3
	writeBuffer += struct.pack('<B', x)
	byteNum += 1


owfile.write(writeBuffer)


orfile.close()
owfile.close()




